# 开发文档

- useConst 性能优于 useState ，前者表示自己是常量且无法修改。
### AlertDialogExample 询问框已封装
```TypeScript
/*
options:{
  title ：标题
  desc: 描述
  cancelText/confirmText：取消/确认
  colorScheme: 确认按钮主题 默认 red
  callback:传递数据 
  }

  callback建议结构{
    key:"回调key",
    options:回调参数
  }
*/
//父组件
import AlertDialogExample from "../../components/alert"
//接纳组件的open方法
const [alertRef, setAlertRef] = useState(Object); 
//写入dom
<AlertDialogExample setting={(res: Function) => setAlertRef(res)} cancel={取消回调} confirm={确认回调} />    
//open方法
alertRef.open(options);
```


### 已对Header空间提供扩展
```ts
className="header-box-extend";
//放置在组件最外层的第一里层
 <Box display={"flex"}>
      <Box className='header-box-extend'>
        //header-extend
      </Box>
      //...order
</Box>
//被此元素包裹的内容将出现在头部
```

### 表格属性已配置
```ts
// 表头  
  const historyColumns = useConst(
{ code: 'apiData', title: '传递参数',align:"center" , tooltip:true, maxW:"240"}
  )
  // 数据  注意 useConst 是声明常量 如果你可能会修改数据，就使用 useState 代替
  const historyData = useConst(
    [
      { time: '2023-1-10', apiAddress: '/admin/apis' , apiData:'"title":"hello"'},
      { time: '2022-4-10', apiAddress: '/admin/open' , apiData:'"title":"hello"'},
      { time: '2021-10-10', apiAddress: '/admin/apis/tip' , apiData:'无'},
    ]
  )
  import { handleExportCurrentExcel } from '../../utils/creatExcel';
  //导出表格 详见引入文件
    function downLoadExcel(){
    const options = {
      fileName:"excel表格",
      columns:historyColumns,
      data:historyData
    }
    handleExportCurrentExcel(options).then(res=>{
      toast({
        title: '导出成功',
        status: "success",
        isClosable: true,
      })
    });
  }

            <TableContainer overflow={"hidden"}>
              <Table size={"md"}>
                <Thead>
                  <Tr>
                    {
                      historyColumns.map((item: any, index: any) => (
                        <Th key={index} textAlign={item.align}>{item.title}</Th>
                      ))
                    }
                  </Tr>
                </Thead>
                <Tbody>
                  {
                    historyData.map((item: any, index: any) => (
                      <Tr key={index}>
                        {
                          historyColumns.map((tdItem: any, tdIndex: any) => (
                            <Td key={tdIndex} textAlign={tdItem.align}>
                              {
                                tdItem.tooltip ?
                                <Tooltip label={item[tdItem.code]}>
                                  <Text maxW={(tdItem.maxW || 400) + "px"} textAlign={tdItem.align} className='table-td-text'>{item[tdItem.code]}</Text>
                                </Tooltip>
                                :
                                <Text maxW={(tdItem.maxW || 400) + "px"} textAlign={tdItem.align} className='table-td-text'>{item[tdItem.code]}</Text>
                              }
                            </Td>
                          ))
                        }
                      </Tr>
                    ))
                  }
                </Tbody>
              </Table>
            </TableContainer>

            <Button color={"green.500"} onClick={downLoadExcel}>
              导出Excel表格
            </Button>
```
 ### 树形选择器
 ```ts
 //array 结构体
 interface checkitem {
    menuName: string
    checked: boolean
    children: Array<{
        name: string
        checked: boolean
    }>
}
 <TreeCheckBox array={[]}  />
 ```
  ### Link链接
 ```ts
<BwlLink  desc="路由表在目录管理中配置" link={"/"} />
 ```
```ts
array.every(function) 是否全部满足
array.some(function) 是否有至少一个满足
```