import { Button, useDisclosure } from "@chakra-ui/react"
import { useEffect, useState } from "react";
import {
    AlertDialog,
    AlertDialogBody,
    AlertDialogFooter,
    AlertDialogHeader,
    AlertDialogContent,
    AlertDialogOverlay,
} from '@chakra-ui/react'
import React from "react";
export default function AlertDialogExample(props: any) {
    const { isOpen, onOpen, onClose } = useDisclosure();
    const cancelRef = React.useRef();
    const [config, setConfig] = useState(Object);
    const confirm = () => { onClose(); props.confirm&&props.confirm(config&&config.callback) };
    const cancel = () => { onClose(); props.cancel&&props.cancel(config&&config.callback) };
    useEffect(() => {
        props.setting({ "open": (options:Object)=>{setConfig(options);onOpen()}  }); //暴露open给父组件
    }, []);
    return (
        <AlertDialog
            isOpen={isOpen}
            leastDestructiveRef={cancelRef}
            onClose={cancel}
        >
            <AlertDialogOverlay>
                <AlertDialogContent>
                    <AlertDialogHeader fontSize='lg' fontWeight='bold'>
                        {config&&config.title || " 操作确认？"}
                    </AlertDialogHeader>

                    <AlertDialogBody>
                        {config&&config.desc}
                    </AlertDialogBody>

                    <AlertDialogFooter>
                        <Button onClick={cancel}>
                            {config&&config.cancelText || "取消"}
                        </Button>
                        <Button colorScheme={config&&config.colorScheme || 'red'} onClick={confirm} ml={3}>
                            {config&&config.confirmText || "确认"}
                        </Button>
                    </AlertDialogFooter>
                </AlertDialogContent>
            </AlertDialogOverlay>
        </AlertDialog>
    )
}