import { Box, Text,HStack} from '@chakra-ui/react';
import { useState } from 'react';
import { useNavigate } from "react-router-dom"
import AlertDialogExample from './alert';
const BwlLink = (props: any) => {
    const [alertRef, setAlertRef] = useState(Object);
    const navigate = useNavigate();
    function onClick(){
        if(!props.useConfirm){
            return navigate(props.link);
        }
        alertRef.open({
            title:"是您要跳转吗？",
            desc:"目标地址是 ' "+props.link+" '",
            colorScheme: "twitter",
        });
    }
    function alertConfirm() {
        navigate(props.link);
    };
    return (
        <Box cursor="pointer" onClick={onClick}>
            <HStack>
                <Text _hover={{"opacity":".6"}} color={"gray.400"}>{props.desc}</Text>
            </HStack>
            <AlertDialogExample setting={(res: Function) => setAlertRef(res)} confirm={alertConfirm} />
        </Box>
    );
};


export default BwlLink;