import React, { useState } from 'react';
import { Card, Box, Checkbox, Stack } from '@chakra-ui/react';
import dep from '../utils/deepClone';

// 遵循目录结构法则 menuName目录名 name菜单名
interface checkitem {
    menuName: string
    checked: boolean
    children: Array<{
        name: string
        checked: boolean
    }>
}
interface Porps {
    array: Array<checkitem>
    onChange?: (array: Array<checkitem>) => void
}
const TreeCheckBox: React.FC<Porps> = ({ array, onChange }) => {
    const array2 = [
        {
            menuName: "111",
            checked: false,
            children: [{
                name: "111-1",
                checked: true
            }, {
                name: "111-2",
                checked: false
            }]
        }, {
            menuName: "222",
            checked: false,
            children: [{
                name: "222-1",
                checked: false
            }, {
                name: "222-2",
                checked: false
            }]
        }
    ]
    const [allList, setAllList] = React.useState(array2) //源列表
    async function setAllchange(state: boolean, index: number) {
        const arr = dep.deepClone(allList);
        const newArr = await arr[index].children.map((ks: any) => {
            return {
                name: ks.name,
                checked: state
            }
        });
        arr.splice(index - 2, 1, {
            menuName: arr[index].menuName,
            checked: state,
            children: newArr
        })
        onChange && onChange(arr);
        return arr;
    }
    async function setItemchange(state: boolean, index: number, cindex: number) {
        let arr = dep.deepClone(allList);
        arr[index].children[cindex].checked = state;
        return arr;
    }
    return (
        <Card px={4} py={6}>
            {
                allList.map((item: any, index: number) => (
                    <Box key={index}>
                        <Checkbox
                            size='lg' colorScheme='teal'
                            isChecked={item.children.every((k: checkitem) => { return k.checked })}
                            isIndeterminate={item.children.some((k: checkitem) => { return k.checked }) && !item.children.every((k: checkitem) => { return k.checked })}
                            onChange={async (e) => setAllchange(e.target.checked, index).then(e => { setAllList(e) })}
                        >
                            {item.menuName}
                        </Checkbox>
                        <Stack pl={6} mt={1} spacing={1}>
                            {
                                item.children.map((citem: any, cindex: number) => (
                                    <Checkbox
                                        size='lg' colorScheme='teal'
                                        key={cindex}
                                        isChecked={citem.checked}
                                        onChange={(e) => setItemchange(e.target.checked, index, cindex).then(e => { setAllList(e) })}
                                    >
                                        {citem.name}
                                    </Checkbox>
                                ))
                            }

                        </Stack>
                    </Box>
                ))
            }
        </Card>
    );
};

export default TreeCheckBox;
