import { Routes, Route, BrowserRouter as Router } from "react-router-dom";
import { Suspense } from "react";
import routeList from "./routeList"
import "./loading.css"

// 封装一层 专门负责显示页面标题
const DomTitle = ({ item }: any) => {
  document.title = item.title;
  return <item.component />
}
const MyRouter = () => (
  <Router>
    <Suspense fallback={
      <div className="spinner-loading-box">
        <div className="spinner-loading"></div>
      </div>
    }>
      <Routes>
        {
          routeList.map((item: any, index) => (
            <Route key={index} path={item.path} element={<DomTitle item={item} />}>
              {
                item.children && item.children.map((citem: any, cindex:any) => (
                  <Route key={cindex} path={item.path+citem.path} element={<DomTitle item={citem} />}></Route>
                ))
              }
            </Route>
          ))
        }
      </Routes>
    </Suspense>
  </Router>
);

export default MyRouter;