//用户鉴权模块
/*
isAdmin ： 是否超级管理员
isUserRoute : 用户可用路由表  
isAllRoute : 全部路由
*/
import { getMenuConfig, getUserRoute } from "../../apis/user"
import layoutChildren from '../../router/layoutChildren';
import create from 'zustand'
import { persist } from "zustand/middleware"
import dep  from "../../utils/deepClone";
const layoutData = layoutChildren.map(item => {
    return {
        "path": item.path,
        "name": item.name,
        "isMenu": false
    }
});
let userRoute: Array<any> = [], menu: Array<any> = [];
const isRouteData = async () => {
    await getUserRoute().then((userRouteres: any) => {
        userRoute = userRouteres.data;
    });
    await getMenuConfig().then((menures: any) => {
        menu = menures.data;
    });
    return true
}
const isSumRout = () => {
    return new Promise((resolve: any, reject: any) => {
        let form = {
            menu_list: [] as any[],
            order_list: [] as any[]
        };
        form.menu_list = menu.map(item => {
            return {
                "menu_name": item.menu_name,
                "path_list": item.path_list.map((g: String) => {
                    return layoutData.find((obj: any) => {
                        if (obj.path === g) {
                            obj.isMenu = true;
                            return true;
                        }
                    });
                })
            }
        });
        form.order_list = layoutData.filter(item => !item.isMenu);
        const aRoute = { ...form };

        let uForm =  dep.deepClone(form);
        uForm.menu_list.forEach((element: any) => {
            element.path_list = element.path_list.filter((item: any) => {
                return userRoute.indexOf(item.path) != -1;
            });
        });
        uForm.order_list = uForm.order_list.filter((item: any) => userRoute.indexOf(item.path) != -1);
        resolve({ aRoute, uForm });
    })
}
let auth: any = (set: Function, get: Function) => ({
    isAdmin: false,
    isAllRoute: {},
    isUserRoute: {},
    openSignIn: () => {
        return new Promise((resolve: any, reject: any) => {
            isRouteData().then(() => {
                isSumRout().then((res: any) => {
                    setTimeout(() => {
                        set(() => ({ isAllRoute: res.aRoute }));
                        set(() => ({ isUserRoute: res.uForm }));
                        resolve();
                    }, 0);
                })
            });
        })
    },//用户开始登录，期间出现错误便拒绝登录
    getAuthLayout: () => { return layoutData },
});
auth = persist(auth, { name: "auth-basket" });
export default create(auth);