/*
    组件状态模块;
    将需要保存状态值的组件写入state，重新渲染时将其读取并卸载。
*/
import create from 'zustand'
import { persist } from "zustand/middleware"
let pageKeepAlive: any = (set: Function, get: Function) => ({
    pageList: {},
    setForKey: (key: string, data: any) => {
        set((state: { pageList: Object }) => ({ pageList: { ...state.pageList, [key]: data } }))
    },
    removeForKey:(key:string)=>{
        let list =  get().pageList[key]
        delete list[key];
        set({ pageList: list });
    },
    removeAll: () => {
        return new Promise((resolve: any, reject: any) => {
            localStorage.removeItem("pageKeepAlive-basket");
            resolve("removeKeepAlive Success!");
        })
    },
});
pageKeepAlive = persist(pageKeepAlive, { name: "pageKeepAlive-basket" });
export default create(pageKeepAlive);