// 表格导出方法
// https://github.com/kinddde/js-export-excel
/*
     ExcelData:{
        fileName:"文件名" 非必须
        columns:[]  表头  必须
        data：[] 数据  必须
     }
*/
import { isEmpty } from "./iFunction";
import ExportJsonExcel from "js-export-excel";
// 一个工作簿 
export const handleExportCurrentExcel = async (ExcelData: any) => { //ExcelData为后端返回的data数组
    if (isEmpty(ExcelData.columns) || isEmpty(ExcelData.data)) {
        return console.error("表属性不完整")
    };
    let option = {
        fileName: ExcelData.fileName || "new Excel",
        datas: [] as any
    };
     option.datas = [
        {
            sheetData: ExcelData.data,
            sheetFilter: ExcelData.columns.map((t: { code: string }) => {
                return t.code;
            }),
            sheetHeader: ExcelData.columns.map((t: { title: string }) => {
                return t.title;
            }),
        },
    ];
    var toExcel = new ExportJsonExcel(option); //new
    await toExcel.saveExcel(); //保存
    return true;
}
/*
    ExcelData:{
    fileName:"文件名" 非必须
    sheets:[
        {
        sheetName:"工作簿名" 非必须
        columns:[]  表头  必须
        data：[] 数据  必须
        },
        {
        columns:[]  表头  必须
        data：[] 数据  必须
        }
    ]
 }
*/

// 多个工作簿
export const handleExportCurrentExceles =  async (ExcelData: any) => { //ExcelData为后端返回的data数组
    if (isEmpty(ExcelData.columns) || isEmpty(ExcelData.data)) {
        return console.error("表属性不完整")
    };
    let option = {
        fileName: ExcelData.fileName || "new Excel",
        datas: [] as any
    };
    option.datas = ExcelData.sheets.map((item: { sheetName: string, columns: Array<any>, data: Array<any> }, index: number) => {
        return {
            sheetName: item.sheetName || ("sheet" + (index + 1)),
            sheetData: item.data,
            sheetFilter: item.columns.map((t: { code: string }) => {
                return t.code;
            }),
            sheetHeader: item.columns.map((t: { title: string }) => {
                return t.title;
            }),
        }
    })
    var toExcel = new ExportJsonExcel(option); //new
    await toExcel.saveExcel(); //保存
    return true;
}