import axios from "axios"

axios.defaults.baseURL = import.meta.env.VITE_APP_BASE_API;
axios.defaults.withCredentials = true;
//后端将会显示跨域；在后端增加 response 头信息Access-Control-Allow-Origin必须指定域名，而不能指定为*。

axios.interceptors.request.use(
    (config) => {
        config.data = config.data;
        config.headers["Content-Type"] = 'application/json';
        // config.headers["Authorization"] = "test-token";
        return config;
    }, (error) => {
        return Promise.reject(error);
    }
);

axios.interceptors.response.use(
    (response) => {
        const res = response.data
        if (res.code === 401) {
            console.info("鉴权失败")
            return Promise.reject('error')
        } else {
            return response
        }
    }, (error: any) => {
        console.info('err' + error)// for debug
        return Promise.reject(error)
    })

export default axios