import { Avatar, Box, HStack, MenuButton, Text, Menu, MenuList, MenuItem, Button, Tooltip, useToast } from "@chakra-ui/react"
import { useState } from "react"
import { FaAngleDown } from "react-icons/fa"
import { useLocation, useNavigate } from "react-router-dom"
import store from '../../store'
function HeaderDom() {
    return store.temp().headerDom;
}
export default function Header(props: any) {
    let pageName = useState("吸鼠霸王");
    const location = useLocation();
    const getAuthLayout = store.auth().getAuthLayout;
    pageName = getAuthLayout().find(function (obj: any) { return (obj.path) === location.pathname }).name;
    const getURoute = store.auth().isUserRoute;
    const navigator = useNavigate();
    const iNav = (path: string) => navigator(path);
    const uSignOut = store.user().signOut;
    const signOut = () => uSignOut().then(() => navigator("/login"));
    const setShowSilder = () => props.onSetShowSilder();
    return (
        <Box>
            <Box flexShrink={0} h={"80px"} display="flex" pl={8} pr={16} alignItems="center" justifyContent="space-between">
                <HStack display="flex">
                    <Tooltip label='切换侧边栏状态'>
                        <Text onClick={setShowSilder} cursor={"pointer"} as={"b"} flexShrink={0} mr={8} fontSize={32}>吸鼠霸王</Text>
                    </Tooltip>
                    <Box className="op-All">
                        <HeaderDom />
                    </Box>
                </HStack>
                <HStack>
                    <Box mr={12}>
                        <Menu>
                            <MenuButton textAlign={"left"} w={240} as={Button} rightIcon={<FaAngleDown />}>
                                <Text as="b" fontSize={16}><>{pageName}</></Text>
                            </MenuButton>
                            <MenuList>
                                {
                                    getURoute.menu_list.map((item: any, index: any) => (
                                        <Box key={index}>
                                            <Text fontSize={12} color={"gray.400"} px={2}>{item.menu_name}</Text>
                                            {
                                                item.path_list.map((citem: any, cindex: any) => (
                                                    <MenuItem key={cindex} w={240} display="flex" justifyContent={"space-between"} onClick={() => iNav(citem.path)} >
                                                        <Text as="b" >{citem.name}</Text>
                                                        {/* <Text color={"gray.300"}>{item.path}</Text> */}
                                                    </MenuItem>
                                                ))
                                            }
                                        </Box>
                                    ))
                                }
                                <Box>
                                    <Text fontSize={12} color={"gray.400"} px={2}>其他</Text>
                                    {
                                        getURoute.order_list.map((citem: any, cindex: any) => (
                                            <MenuItem key={cindex} w={240} display="flex" justifyContent={"space-between"} onClick={() => iNav(citem.path)} >
                                                <Text as="b" >{citem.name}</Text>
                                                {/* <Text color={"gray.300"}>{item.path}</Text> */}
                                            </MenuItem>
                                        ))
                                    }
                                </Box>
                            </MenuList>
                        </Menu>
                    </Box>
                    <Menu>
                        <MenuButton as={Button} rightIcon={<FaAngleDown />}>
                            <Text as="b" fontSize={16}>吸鼠霸王</Text>
                        </MenuButton>
                        <MenuList>
                            <MenuItem color="gray.300" cursor="not-allowed">查看消息</MenuItem>
                            <MenuItem color="gray.300" cursor="not-allowed">修改密码</MenuItem>
                            <MenuItem onClick={setShowSilder}>打开/关闭 侧边栏</MenuItem>
                            <MenuItem color="red.500" onClick={signOut}>退出登录</MenuItem>
                        </MenuList>
                    </Menu>
                    <Avatar name='吸鼠霸王' src='http://q1.qlogo.cn/g?b=qq&nk=762444787&s=640' />
                </HStack>
            </Box>
        </Box>
    );
}
