import { Box } from "@chakra-ui/react"
import { useState } from "react";
import { Outlet } from "react-router-dom"
import store from "../../store";
import Header from "./header"
import Silder from "./silder"
function LayoutPage() {
    const configShowSilder = store.config(((state: { showSilder: boolean }) => state.showSilder));
    const storeSetShowSilder = store.config(((state: { setShowSilder: Function }) => state.setShowSilder));
    const [showSilder, setShowSilder] = useState(configShowSilder);
    return (
        <Box display="flex" flexDirection={"column"}>
            <Header onSetShowSilder={() => {
                storeSetShowSilder(!showSilder);
                setShowSilder(!showSilder);
            }} />
            <Box display="flex" flex={1}>
                <Box display={"flex"} justifyContent={"center"} transition={"width 400ms"} height="calc(100vh - 80px)" overflowX={"hidden"} w={showSilder ? "200px" : "0"} flexShrink={0} >
                    <Silder />
                </Box>
                <Box flex={1} px={8} height="calc(100vh - 80px)" overflowY={"auto"}>
                    <Outlet />
                </Box>
            </Box>
        </Box>
    )
}
export default LayoutPage