import { Box, Center, Image, Text, FormControl, Divider, FormLabel, Input, Card, CardBody, Button, CardFooter, InputGroup, InputLeftElement, AvatarGroup, Avatar, useToast } from "@chakra-ui/react"
import { useState } from "react"
import { FaJenkins, FaGrunt } from "react-icons/fa"
import { useNavigate } from 'react-router-dom'
import "./index.css"
import store from "../../store";
import { QRCode } from 'antd';
import { isEmpty } from "../../utils/iFunction"
const QrCode: React.FC = () => <QRCode icon="http://q1.qlogo.cn/g?b=qq&nk=762444787&s=640" value="http://q1.qlogo.cn/g?b=qq&nk=762444787&s=640" />;
function Login() {
  const navigate = useNavigate();
  const toast = useToast();
  const [loadingLogin, setloadingLogin] = useState(false);
  const [phoneValue, setPhoneValue] = useState("");
  const [passwordValue, setPasswordValue] = useState("");
  const phoneValueChange = (event: any) => setPhoneValue(event.target.value)
  const passwordValueChange = (event: any) => setPasswordValue(event.target.value)
  const openSignIn = store.auth(((state: { openSignIn: Function }) => state.openSignIn));

  const onlogin = () => {
    if (isEmpty(phoneValue) || isEmpty(passwordValue)) {
      return toast({
        title: '账号 或 密码 为空',
        status: "error",
        isClosable: true,
      })
    };
    setloadingLogin(true);
    // if (phoneValue != "123" || passwordValue != "456") {
    //   setloadingLogin(false);
    //   return toast({
    //     title: '账号 或 密码 错误的',
    //     status: "error",
    //     isClosable: true,
    //   })
    // }
    openSignIn().then(() => {
      setloadingLogin(false);
      navigate("/");
    })
  };
  return (
    <Center h="100vh" w="100vw">
      <div className="main-bg"></div>
      <Card >
        <CardBody display={"flex"} gap={4} alignItems="center">
          <Box>
          <QrCode />
             {/* <Image borderRadius={4} boxSize='200px' src="http://q1.qlogo.cn/g?b=qq&nk=762444787&s=640"></Image> */}
            <Text fontSize="12px" mt={4} textAlign="center" color={"gray.300"}>微信扫码登录</Text>
          </Box>
          <Divider orientation='vertical' minH={40} />
          <Box>
            <FormLabel>当前在线的管理员</FormLabel>
            <AvatarGroup size='md' max={3}>
              <Avatar name='Admin' src='https://img0.baidu.com/it/u=1250551608,2180019998&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=500' />
              <Avatar name='Segun Adebayo' src='https://gimg2.baidu.com/image_search/src=http%3A%2F%2Fc-ssl.duitang.com%2Fuploads%2Fblog%2F202106%2F09%2F20210609081952_51ef5.thumb.1000_0.jpg&refer=http%3A%2F%2Fc-ssl.duitang.com&app=2002&size=f9999,10000&q=a80&n=0&g=0n&fmt=auto?sec=1679625622&t=b56d850addbf4830f3eaf469f809abde' />
              <Avatar name='Kent Dodds' src='https://gimg2.baidu.com/image_search/src=http%3A%2F%2Fc-ssl.duitang.com%2Fuploads%2Fblog%2F202106%2F13%2F20210613235426_7a793.thumb.1000_0.jpeg&refer=http%3A%2F%2Fc-ssl.duitang.com&app=2002&size=f9999,10000&q=a80&n=0&g=0n&fmt=auto?sec=1679625622&t=9757520cbac94702fa3c0f0d5ec5d77b' />
              <Avatar name='Prosper Otemuyiwa' src='https://bit.ly/prosper-baba' />
              <Avatar name='Christian Nwamba' src='https://bit.ly/code-beast' />
            </AvatarGroup>
            <FormControl>
              <FormLabel>Token number</FormLabel>
              <InputGroup>
                <InputLeftElement
                  pointerEvents='none'
                  children={<FaJenkins className="default-icon" />}
                />
                <Input placeholder='Token number' value={phoneValue} onChange={phoneValueChange} />
              </InputGroup>
              <FormLabel>Token password</FormLabel>
              <InputGroup>
                <InputLeftElement
                  pointerEvents='none'
                  children={<FaGrunt className="default-icon" />}
                />
                <Input placeholder='Token password' value={passwordValue} onChange={passwordValueChange} />
              </InputGroup>
            </FormControl>
            <Box display='flex' justifyContent='flex-end' mt={12}>
              <Button colorScheme='teal' onClick={onlogin}
                isLoading={loadingLogin}
                loadingText='Loading'
                variant='outline'
                spinnerPlacement='end'>
                Log in
              </Button>
            </Box>
          </Box>
        </CardBody>
      </Card>
    </Center>
  )
}

export default Login