import { Box, Button, HStack, useToast } from "@chakra-ui/react"
import ReactQuillEditor from "../../components/quill"
import { useEffect, useState } from "react";
import store from '../../store'
import { useLocation } from "react-router-dom";

function Quill() {  
  const location = useLocation();
  const quillPageValue = store.pageKeepAlive(((state: { pageList: { quillPageValue: Object } }) => state.pageList.quillPageValue));
  const setForKey = store.pageKeepAlive(((state: { setForKey: Function }) => state.setForKey));
  const [quillValue,setquillValue] = useState(quillPageValue&&quillPageValue.reactQuillValue||"");
  const toast = useToast();
  const getQuillValue = () => {
    toast({
      title: 'Success',
      description: quillValue,
      status: 'success',
      duration: 9000,
      isClosable: true,
    })
  };
  useEffect(() => {
    return () => {
      setForKey("quillPageValue",{pageName:location.pathname ,reactQuillValue:quillValue});
    }
  }, [quillValue]);
  return (
    <Box>
      <ReactQuillEditor onSetValue={setquillValue} value={quillValue} />
      <HStack my={4} display="flex" justifyContent={"flex-end"}>
        <Button colorScheme='blue' onClick={() => { getQuillValue() }}>getValue</Button>
       </HStack>
    </Box>
  )
}

export default Quill